#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=beta
#AutoIt3Wrapper_icon=icon.ico
#AutoIt3Wrapper_outfile=Vistumbler.exe
#AutoIt3Wrapper_Run_Tidy=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;--------------------------------------------------------
;AutoIt Version: 3.2.9.3 Beta
$Script_Author = 'Andrew Calcutt' 
$Script_Start_Date = '07/09/2007' 
$Script_Name = 'Vistumbler' 
$Script_Function = 'A netstumbler like program for vista. This Program uses "netsh wlan show networks mode=bssid" to get wireless information.' 
$version = 'v5.8 Beta' 
$last_modified = '10/15/2007' 
$title = $Script_Name & ' ' & $version & ' - By ' & $Script_Author & ' - ' & $last_modified
;Includes------------------------------------------------
#include <File.au3>
#include <Array.au3>
#include <Process.au3>
#include <GuiConstants.au3>
#Include <GuiListView.au3>
#include <WindowsConstants.au3>
#include <GuiTreeView.au3>
; Set a COM Error handler--------------------------------
$oMyError = ObjEvent("AutoIt.Error", "MyErrFunc")
;Register-Netcomm-OCX------------------------------------
;_RunDOS('REGSVR32.EXE /s "' & @ScriptDir & '\NETComm.ocx"')
;Options-------------------------------------------------
Opt("TrayIconHide", 1);Hide icon in system tray
Opt("GUIOnEventMode", 1);Change to OnEvent mode
Opt("RunErrorsFatal", 0)
;Non Vista Warning---------------------------------------
If @OSVersion <> "WIN_VISTA"  Then MsgBox(0, "Warning", "This Program will only run in Vista. It relies on a netsh command that is not avalible in older versions of windows")
;Declair-Variables---------------------------------------
;Dim $WS_EX_CONTROLPARENT = 0x00010000
Dim $data_history, $data_old
Dim $sizes, $sizes_old
Dim $base_add = 0, $data, $data_old, $Graph = 0, $Graph_old, $Redraw = 1

Dim $TreeviewAPs_left, $TreeviewAPs_width, $TreeviewAPs_top, $TreeviewAPs_height
Dim $ListviewAPs_left, $ListviewAPs_width, $ListviewAPs_top, $ListviewAPs_height
Dim $Graphic_left, $Graphic_width, $Graphic_top, $Graphic_height


Dim $tempfile = _TempFile(@TempDir, "~vistumbler-")
;Dim $tempfile = 'test.txt'
Dim $settings = @ScriptDir & '\vistumbler_settings.ini' 
Dim $labelsini = 'mac_labels.ini' 
Dim $Latitude = 'N 0.0000000' 
Dim $Longitude = 'E 0.0000000' 
Dim $UseGPS = 0
Dim $SortList = 0
Dim $Scan = 0
Dim $Exit = 0
Dim $ComError = 0
Dim $disconnected_time = -1
Dim $TempFileArray, $OpenArray, $oMyError, $temp, $LatTest, $gps, $NetComm, $CommPort, $Sort, $timestamp, $timestamp1, $timestamp2, $sort_timer, $headers, $basetimestamp, $timestamp_timer
Dim $SSID, $NetworkType, $Authentication, $Encryption, $BSSID, $Signal, $RadioType, $Channel, $BasicTransferRates, $OtherTransferRates, $display, $ActiveBSSIDs, $ActiveBSSIDs_old, $ActiveSSIDs, $ActiveSSIDs_old, $ActiveData, $ActiveData_old
Dim $manu_mac[1], $manu_manu[1], $label_mac[1], $label_label[1], $channel_array[1], $channel_position[1], $SSID_array[1], $SSID_position[1], $Encryption_array[1], $Encryption_position[1], $Authentication_array[1], $Authentication_position[1], $NetworkType_array[1], $NetworkType_position[1]
Dim $Direction[18], $Direction2[4]
Dim $Array_Temp_BSSID[1], $Array_Temp_SSID[1], $Array_Temp_Signal[1], $Array_Temp_Authentication[1], $Array_Temp_Encryption[1], $Array_Temp_RadioType[1], $Array_Temp_Channel[1], $Array_Temp_BasicTransferRates[1], $Array_Temp_OtherTransferRates[1], $Array_Temp_NetworkType[1], $Array_Temp_TimeStamp[1]

;Load-Settings-From-INI-File----------------------------
Dim $netsh = IniRead($settings, 'Vistumbler', 'Netsh_exe', 'netsh.exe')
Dim $ComPort = IniRead($settings, 'Vistumbler', 'ComPort', 8)
Dim $BAUD = IniRead($settings, 'Vistumbler', 'Baud', 4800)
Dim $saved_sleeptime = IniRead($settings, 'Vistumbler', 'Sleeptime', 1000)
Dim $SortTime = IniRead($settings, 'Vistumbler', 'AutoSortTime', 60)
Dim $SortBy = IniRead($settings, 'Vistumbler', 'SortCombo', 'Sort by SSID')
Dim $SortDirection = IniRead($settings, 'Vistumbler', 'AscDecDefault', 'Decending')
Dim $AutoSort = IniRead($settings, 'Vistumbler', 'AutoSort', 0)
Dim $SoundOnAP = IniRead($settings, 'Vistumbler', 'PlaySoundOnNewAP', 0)
Dim $new_AP_sound = IniRead($settings, 'Vistumbler', 'NewAP_Sound', 'new_ap.wav')
Dim $error_sound = IniRead($settings, 'Vistumbler', 'Error_Sound', 'error.wav')
Dim $AddDirection = IniRead($settings, 'Vistumbler', 'NewApPosistion', 0)
Dim $BackgroundColor = IniRead($settings, 'Vistumbler', 'BackgroundColor', "0x99B4D1")
Dim $ControlBackgroundColor = IniRead($settings, 'Vistumbler', 'ControlBackgroundColor', "0xD7E4F2")
Dim $column_Active = IniRead($settings, 'Columns', 'Column_Active', 0)
Dim $column_SSID = IniRead($settings, 'Columns', 'Column_SSID', 1)
Dim $column_BSSID = IniRead($settings, 'Columns', 'Column_BSSID', 2)
Dim $column_MANUF = IniRead($settings, 'Columns', 'Column_Manufacturer', 3)
Dim $column_Signal = IniRead($settings, 'Columns', 'Column_Signal', 4)
Dim $column_Authentication = IniRead($settings, 'Columns', 'Column_Authentication', 5)
Dim $column_Encryption = IniRead($settings, 'Columns', 'Column_Encryption', 6)
Dim $column_RadioType = IniRead($settings, 'Columns', 'Column_RadioType', 7)
Dim $column_Channel = IniRead($settings, 'Columns', 'Column_Channel', 8)
Dim $column_Latitude = IniRead($settings, 'Columns', 'Column_Latitude', 9)
Dim $column_Longitude = IniRead($settings, 'Columns', 'Column_Longitude', 10)
Dim $column_BasicTransferRates = IniRead($settings, 'Columns', 'Column_BasicTransferRates', 11)
Dim $column_OtherTransferRates = IniRead($settings, 'Columns', 'Column_OtherTransferRates', 12)
Dim $column_FirstActive = IniRead($settings, 'Columns', 'Column_FirstActive', 13)
Dim $column_LastActive = IniRead($settings, 'Columns', 'Column_LastActive', 14)
Dim $column_NetworkType = IniRead($settings, 'Columns', 'Column_NetworkType', 15)
Dim $column_Label = IniRead($settings, 'Columns', 'Column_Label', 16)
Dim $column_SignalHistory = IniRead($settings, 'Columns', 'Column_SignalHistory', 17)
Dim $column_SignalHistory2 = IniRead($settings, 'Columns', 'Column_SignalHistory2', 17)

Dim $column_Width_Active = IniRead($settings, 'Column_Width', 'Column_Active', 50)
Dim $column_Width_SSID = IniRead($settings, 'Column_Width', 'Column_SSID', 50)
Dim $column_Width_BSSID = IniRead($settings, 'Column_Width', 'Column_BSSID', 50)
Dim $column_Width_MANUF = IniRead($settings, 'Column_Width', 'Column_Manufacturer', 50)
Dim $column_Width_Signal = IniRead($settings, 'Column_Width', 'Column_Signal', 50)
Dim $column_Width_Authentication = IniRead($settings, 'Column_Width', 'Column_Authentication', 50)
Dim $column_Width_Encryption = IniRead($settings, 'Column_Width', 'Column_Encryption', 50)
Dim $column_Width_RadioType = IniRead($settings, 'Column_Width', 'Column_RadioType', 50)
Dim $column_Width_Channel = IniRead($settings, 'Column_Width', 'Column_Channel', 50)
Dim $column_Width_Latitude = IniRead($settings, 'Column_Width', 'Column_Latitude', 50)
Dim $column_Width_Longitude = IniRead($settings, 'Column_Width', 'Column_Longitude', 50)
Dim $column_Width_BasicTransferRates = IniRead($settings, 'Column_Width', 'Column_BasicTransferRates', 50)
Dim $column_Width_OtherTransferRates = IniRead($settings, 'Column_Width', 'Column_OtherTransferRates', 50)
Dim $column_Width_FirstActive = IniRead($settings, 'Column_Width', 'Column_FirstActive', 50)
Dim $column_Width_LastActive = IniRead($settings, 'Column_Width', 'Column_LastActive', 50)
Dim $column_Width_NetworkType = IniRead($settings, 'Column_Width', 'Column_NetworkType', 50)
Dim $column_Width_Label = IniRead($settings, 'Column_Width', 'Column_Label', 50)
Dim $column_Width_SignalHistory = IniRead($settings, 'Column_Width', 'Column_SignalHistory', 50)
Dim $column_Width_SignalHistory2 = IniRead($settings, 'Column_Width', 'Column_SignalHistory2', 50)

Dim $SearchWord_SSID = IniRead($settings, 'SearchWords', 'SSID', 'SSID')
Dim $SearchWord_BSSID = IniRead($settings, 'SearchWords', 'BSSID', 'BSSID')
Dim $SearchWord_NetworkType = IniRead($settings, 'SearchWords', 'NetworkType', 'Network type')
Dim $SearchWord_Authentication = IniRead($settings, 'SearchWords', 'Authentication', 'Authentication')
Dim $SearchWord_Encryption = IniRead($settings, 'SearchWords', 'Encryption', 'Encryption')
Dim $SearchWord_Signal = IniRead($settings, 'SearchWords', 'Signal', 'Signal')
Dim $SearchWord_RadioType = IniRead($settings, 'SearchWords', 'RadioType', 'Radio Type')
Dim $SearchWord_Channel = IniRead($settings, 'SearchWords', 'Channel', 'Channel')
Dim $SearchWord_BasicRates = IniRead($settings, 'SearchWords', 'BasicRates', 'Basic Rates')
Dim $SearchWord_OtherRates = IniRead($settings, 'SearchWords', 'OtherRates', 'Other Rates')

;Create-Array-Of-Manufactures----------------------------
$var = IniReadSection($settings, "MANUFACURERS")
If Not @error Then
	For $i = 1 To $var[0][0]
		_ArrayAdd($manu_mac, $var[$i][0])
		_ArrayAdd($manu_manu, $var[$i][1])
	Next
	$manu_mac[0] = UBound($manu_mac) - 1
	$manu_manu[0] = UBound($manu_manu) - 1
EndIf

;Create-Array-Of-Labels----------------------------
$var = IniReadSection($labelsini, "LABELS")
If Not @error Then
	For $i = 1 To $var[0][0]
		_ArrayAdd($label_mac, $var[$i][0])
		_ArrayAdd($label_label, $var[$i][1])
	Next
	$label_mac[0] = UBound($label_mac) - 1
	$label_label[0] = UBound($label_label) - 1
EndIf

;Ser-Up-Column-Headers-Based-On-INI-File-----------------
$var = IniReadSection($settings, "Columns")
If @error Then
	$headers = 'Active|SSID|BSSID|Manufacturer|Signal|Authentication|Encryption|Radio Type|Channel|Latitude|Longitude|Basic Transfer Rates|Other Transfer Rates|First Active|Last Active|Network Type|Label|Signal History|Signal History 2' 
Else
	For $a = 0 To ($var[0][0] - 1)
		For $b = 1 To $var[0][0]
			If $a = $var[$b][1] Then $headers &= IniRead($settings, 'Column_Names', $var[$b][0], '') & '|' 
		Next
	Next
EndIf

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GUI
;-------------------------------------------------------------------------------------------------------------------------------
$Vistumbler = GUICreate($title, 908, 692, -1, -1, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS))
GUISetBkColor($BackgroundColor)

$File = GUICtrlCreateMenu("&File")
$SaveAsTXT = GUICtrlCreateMenuItem("Save as TXT", $File)
$ImportFromTXT = GUICtrlCreateMenuItem("Import from TXT", $File)
$Exit = GUICtrlCreateMenuItem("Exit", $File)
;$Edit = GUICtrlCreateMenu("&Edit")
;$Cut = GUICtrlCreateMenuitem("Cut", $Edit)
;$Copy = GUICtrlCreateMenuitem("Copy", $Edit)
;$Delete = GUICtrlCreateMenuitem("Delete", $Edit)
;$SelectAll = GUICtrlCreateMenuitem("Select All", $Edit)
$Options = GUICtrlCreateMenu("&Options")
$ScanWifiGUI = GUICtrlCreateMenuItem("Scan for APs", $Options)
$UseGpsGUI = GUICtrlCreateMenuItem("Use GPS", $Options)
$AutoSortGUI = GUICtrlCreateMenuItem("Auto Sort", $Options)
If $AutoSort = 1 Then GUICtrlSetState($AutoSortGUI, $GUI_CHECKED)
$SortTree = GUICtrlCreateMenuItem("Sort Tree  - (slow on big lists)", $Options)
$SetSearchWords = GUICtrlCreateMenuItem("Set netsh search words", $Options)
$PlaySoundOnNewAP = GUICtrlCreateMenuItem("Play sound on new AP", $Options)
If $SoundOnAP = 1 Then GUICtrlSetState($PlaySoundOnNewAP, $GUI_CHECKED)
;$ShowGridLines = GUICtrlCreateMenuitem("Show Grid Lines", $Options)
;GUICtrlSetState(-1, $GUI_CHECKED)
$AddNewAPsToTop = GUICtrlCreateMenuItem("Add new APs to top", $Options)
If $AddDirection = 0 Then GUICtrlSetState(-1, $GUI_CHECKED)
$Export = GUICtrlCreateMenu("E&xport")
$ExportToKML = GUICtrlCreateMenuItem("Export to KML", $Export)
$ExportToTXT2 = GUICtrlCreateMenuItem("Export to TXT", $Export)
$Extra = GUICtrlCreateMenu("Ex&tra")
$ViewInPhilsPHP = GUICtrlCreateMenuItem("View graph (Phil's PHP version)", $Extra)


$DataChild = GUICreate("", 895, 595, 0, 60, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $Vistumbler)
GUISetBkColor($BackgroundColor)
$ListviewAPs = GUICtrlCreateListView($headers, 160, 5, 725, 585, $LVS_REPORT + $LVS_SINGLESEL, $LVS_EX_HEADERDRAGDROP + $LVS_EX_GRIDLINES + $LVS_EX_FULLROWSELECT)
GUICtrlSetBkColor(-1, $ControlBackgroundColor)
$TreeviewAPs = GUICtrlCreateTreeView(5, 5, 150, 585)
GUICtrlSetBkColor(-1, $ControlBackgroundColor)
$Graphic1 = GUICtrlCreateGraphic(0, 0, 0, 0)
GUICtrlSetBkColor(-1, $BackgroundColor)
$Graphic2 = GUICtrlCreateGraphic(0, 0, 0, 0)
GUICtrlSetBkColor(-1, $BackgroundColor)

GUISetState()

$ControlChild = GUICreate("", 908, 65, 0, 0, $WS_CHILD, $WS_EX_CONTROLPARENT, $Vistumbler) ; Create Child window for controls
GUISetBkColor($BackgroundColor)
$ScanButton = GUICtrlCreateButton("Scan APs", 10, 8, 60, 20, 0)
$GpsButton = GUICtrlCreateButton("Use GPS", 75, 8, 60, 20, 0)
GUICtrlCreateLabel("Refresh loop time(mS):", 140, 10, 110, 17)
$sleeptime = GUICtrlCreateInput($saved_sleeptime, 255, 7, 55, 21)
GUICtrlCreateLabel("Actual loop time:", 315, 10, 80, 17)
$timediff = GUICtrlCreateInput("", 400, 7, 70, 21)
GUICtrlCreateLabel("Longitude:", 475, 10, 50, 17)
$GuiLon = GUICtrlCreateInput($Longitude, 528, 7, 81, 21)
GUICtrlCreateLabel("Latitude:", 616, 10, 45, 17)
$GuiLat = GUICtrlCreateInput($Latitude, 662, 7, 81, 21)
GUICtrlCreateLabel("Active APs:", 752, 10, 59, 17)
$ActiveAPs = GUICtrlCreateInput("", 816, 7, 89, 21)
$msgdisplay = GUICtrlCreateLabel("", 140, 38, 665, 17)
$GraphButton1 = GUICtrlCreateButton("Graph1", 10, 35, 60, 20, 0)
$GraphButton2 = GUICtrlCreateButton("Graph1", 75, 35, 60, 20, 0)
GUISetState(@SW_SHOW)

GUISwitch($Vistumbler)
_SetControlSizes()
GUISetState(@SW_SHOW)

;Button-Events-------------------------------------------
GUISetOnEvent($GUI_EVENT_CLOSE, "CLOSEClicked")
GUISetOnEvent($GUI_EVENT_RESIZED, "_ResetSizes")
GUISetOnEvent($GUI_EVENT_MINIMIZE, "_ResetSizes")
GUISetOnEvent($GUI_EVENT_RESTORE, "_ResetSizes")
GUISetOnEvent($GUI_EVENT_MAXIMIZE, "_ResetSizes")
GUISetOnEvent($GUI_EVENT_CLOSE, "CLOSEClicked")
GUISetOnEvent($GUI_EVENT_CLOSE, "CLOSEClicked")
GUICtrlSetOnEvent($ScanButton, "ScanToggle")
GUICtrlSetOnEvent($ScanWifiGUI, "ScanToggle")
GUICtrlSetOnEvent($UseGpsGUI, "_GPSOptions")
GUICtrlSetOnEvent($GpsButton, "_GpsToggle")
GUICtrlSetOnEvent($AutoSortGUI, "_SortOptions")
GUICtrlSetOnEvent($SaveAsTXT, "_ExportData")
GUICtrlSetOnEvent($ImportFromTXT, "LoadList")
GUICtrlSetOnEvent($ExportToKML, "SaveToKML")
GUICtrlSetOnEvent($ExportToTXT2, "_ExportData")
GUICtrlSetOnEvent($PlaySoundOnNewAP, "_SoundToggle")
GUICtrlSetOnEvent($AddNewAPsToTop, "_AddApPosToggle")
GUICtrlSetOnEvent($ListviewAPs, "_HeaderSort")
GUICtrlSetOnEvent($SetSearchWords, "_SearchWordsGUI")
GUICtrlSetOnEvent($SortTree, "_SortTree")
GUICtrlSetOnEvent($GraphButton1, "_GraphToggle")
GUICtrlSetOnEvent($GraphButton2, "_GraphToggle2")
GUICtrlSetOnEvent($ViewInPhilsPHP, "_ViewInPhilsPHP")


;Set column widths - All variables have ' - 0' after them to make this work. it would not set column widths without the ' - 0'
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Active - 0, $column_Width_Active - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_SSID - 0, $column_Width_SSID - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_BSSID - 0, $column_Width_BSSID - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_MANUF - 0, $column_Width_MANUF - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Signal - 0, $column_Width_Signal - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Authentication - 0, $column_Width_Authentication - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Encryption - 0, $column_Width_Encryption - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_RadioType - 0, $column_Width_RadioType - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Channel - 0, $column_Width_Channel - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Latitude - 0, $column_Width_Latitude - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Longitude - 0, $column_Width_Longitude - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_BasicTransferRates - 0, $column_Width_BasicTransferRates - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_OtherTransferRates - 0, $column_Width_OtherTransferRates - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_FirstActive - 0, $column_Width_FirstActive - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_LastActive - 0, $column_Width_LastActive - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_NetworkType - 0, $column_Width_NetworkType - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Label - 0, $column_Width_Label - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_SignalHistory - 0, $column_Width_SignalHistory - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_SignalHistory2 - 0, $column_Width_SignalHistory2 - 0)

Dim $Authentication_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, "Authentication")
Dim $channel_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, "Channels")
Dim $Encryption_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, "Encrytion")
Dim $NetworkType_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, "Neywork Type")
Dim $SSID_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, "SSIDs")

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       PROGRAM RUNNING LOOP
;-------------------------------------------------------------------------------------------------------------------------------

$refresh_gps = TimerInit() ;Start timer for gps refresh
While 1
	$begin = TimerInit() ;Start $begin timer, used to measure loop time
	
	If $Scan = 1 Or $UseGPS = 1 Then
		If $UseGPS = 1 Then ; If 'Use GPS' is checked then scan gps and display information
			$GetGpsSuccess = _GetGPS();Scan for GPS if GPS enabled
			_GpsPositionReset(60000);Reset GPS location to $Latitude = 'N 0.0000000' $Longitude = 'E 0.0000000' if new GPS position not found within timeout _GpsPositionReset($timeout)
			If $GetGpsSuccess = 1 Then
				GUICtrlSetData($msgdisplay, 'Seconds Since GPS Update: ' & Round(TimerDiff($refresh_gps) / 1000) & '/60')
				GUICtrlSetData($GuiLat, $Latitude);Set GPS Latitude in GUI
				GUICtrlSetData($GuiLon, $Longitude);Set GPS Longitude in GUI
			Else
				GUICtrlSetData($msgdisplay, 'GPS Error. Buffer Empty for more than 5 seconds. GPS was probrably disconnected. GPS has been stopped')
				Sleep(1500)
			EndIf
		Else
			GUICtrlSetData($msgdisplay, '') ;Clear Message
		EndIf
		If $Scan = 1 Then _ScanAccessPoints();Scan for Access Points if scanning enabled
		_SetActiveAccessPoints_SetManufacturer();Reset non-active access points; Set 'Active APs' in GUI
		
		If $AutoSort = 1 And TimerDiff($sort_timer) >= ($SortTime * 1000) Then _Sort($SortBy)
		$time = TimerDiff($begin)
		If TimerDiff($begin) <= GUICtrlRead($sleeptime) Then Sleep(GUICtrlRead($sleeptime) - TimerDiff($begin)); If time difference is less then time taken for loop, sleep remaining time
	Else
		_SetActiveAccessPoints_SetManufacturer();Reset non-active access points; Set 'Active APs' in GUI
		$time = TimerDiff($begin)
		Sleep(100)
	EndIf
	_GraphApSignal()
	GUICtrlSetData($timediff, Round($time) & ' / ' & Round(TimerDiff($begin))); & 'mS'); Set 'Actual Loop Time' in GUI
WEnd
Exit

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       WIFI SCAN FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _ScanAccessPoints()
	$basetimestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & ':' & @MIN & ':' & @SEC
	$timestamp_timer = TimerInit()
	_RunDOS($netsh & " wlan show networks mode=bssid > " & $tempfile) ;copy the output of the 'netsh wlan show networks mode=bssid' command to the temp file
	_FileReadToArray($tempfile, $TempFileArray);read the tempfile into the '$TempFileArray' Araay
	FileDelete($tempfile)
	For $loop = 1 To $TempFileArray[0]; loop through the temp file array
		If StringInStr($TempFileArray[$loop], $SearchWord_SSID) Then
			Dim $SSID = '', $NetworkType = '', $Authentication = '', $Encryption = '', $BSSID = '', $Signal = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '', $MANUF ;Clear Variables
			While BitAND(StringInStr($TempFileArray[$loop + 1], $SearchWord_SSID), Not StringInStr($TempFileArray[$loop + 1], $SearchWord_BSSID)) <> 1
				
				;StringInStr($TempFileArray[$loop + 1], $SearchWord_SSID) <> 1 Or StringInStr($TempFileArray[$loop + 1], $SearchWord_BSSID) = 1
				$temp = StringSplit($TempFileArray[$loop], ":")
				If IsArray($temp) Then ; Strip Data from line
					If StringInStr($temp[1], $SearchWord_SSID) = 1 And StringInStr($temp[1], $SearchWord_BSSID) <> 1 Then
						$SSID = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_NetworkType) Then
						$NetworkType = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Authentication) Then
						$Authentication = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Encryption) Then
						$Encryption = StringStripWS($temp[2], 3)
					EndIf
					If StringInStr($temp[1], $SearchWord_BSSID) Then ;
						While 1
							$temp = StringSplit($TempFileArray[$loop], ":")
							If IsArray($temp) Then ; Strip Data from line
								If StringInStr($temp[1], $SearchWord_BSSID) Then
									$BSSID = StringStripWS(StringUpper($temp[2] & ':' & $temp[3] & ':' & $temp[4] & ':' & $temp[5] & ':' & $temp[6] & ':' & $temp[7]), 3)
								ElseIf StringInStr($temp[1], $SearchWord_Signal) Then
									$Signal = StringFormat("%2d", StringTrimRight(StringStripWS($temp[2], 3), 1)) & '%' 
								ElseIf StringInStr($temp[1], $SearchWord_RadioType) Then
									$RadioType = StringStripWS($temp[2], 3)
								ElseIf StringInStr($temp[1], $SearchWord_Channel) Then
									$Channel = StringStripWS($temp[2], 3)
								ElseIf StringInStr($temp[1], $SearchWord_BasicRates) Then
									$BasicTransferRates = StringStripWS($temp[2], 3)
								ElseIf StringInStr($temp[1], $SearchWord_OtherRates) Then
									$OtherTransferRates = StringStripWS($temp[2], 3)
								EndIf
								
							EndIf
							If StringInStr($TempFileArray[$loop + 1], $SearchWord_SSID) <> 0 Or StringInStr($TempFileArray[$loop + 1], $SearchWord_BSSID) <> 0 Or $TempFileArray[$loop + 1] = '' Or ($loop + 1) >= $TempFileArray[0] Then ExitLoop
							$loop += 1
						WEnd
						If $BSSID <> '' Then ; If Mac Address($BSSID) was not empty then see if it is in the list box. If it is, update it. If not, add it
							$ActiveBSSIDs &= $BSSID & '|'                                                                    ; Add found BSSID into $ActiveBSSIDs string for use later displaying Active BSSIDs at end of file read
							$ActiveSSIDs &= $SSID & '|'                                                                    ; Add found BSSID into $ActiveBSSIDs string for use later displaying Active BSSIDs at end of file read
							;$ActiveData &= $Signal & '|' & $SSID & '|' & $BSSID & '|' & $Authentication & '|' & $Encryption & '|' & $RadioType & '|' & $Channel & '|' & $BasicTransferRates & '|' & $OtherTransferRates & '|' & $NetworkType & @CRLF;Create string of APs and DATA. Data is seperated by '[/\_-_/\]'. All AP DATA is seperated by '[\/-_-\/]'.
							$timestamp = $basetimestamp & ' ' & Round((TimerDiff($timestamp_timer)))
							Dim $newlat = $Latitude, $newlon = $Longitude

							$arraysearch = -1
							$itemcount = _GUICtrlListViewGetItemCount($ListviewAPs) - 1; Get List Size
							For $findloop = 0 To $itemcount; Find BSSID list; If found, set $arraysearch with position
								If $AddDirection = -1 Then; Set search direction based on location new APs are being added
									$itemposition = $itemcount - $findloop;Searches from the bottom
								Else
									$itemposition = $findloop;searches from the top
								EndIf
								If _GUICtrlListViewGetItemText($ListviewAPs, $itemposition, $column_BSSID) = $BSSID _
										And _GUICtrlListViewGetItemText($ListviewAPs, $itemposition, $column_SSID) = $SSID _
										And _GUICtrlListViewGetItemText($ListviewAPs, $itemposition, $column_Encryption) = $Encryption _
										And _GUICtrlListViewGetItemText($ListviewAPs, $itemposition, $column_Authentication) = $Authentication Then
									$arraysearch = $itemposition
									ExitLoop
								EndIf
							Next
							
							If $arraysearch = -1 Then ;If BSSID is not found, add it - Else - Update old entry
								$arraysearch = _GUICtrlListViewInsertItem($ListviewAPs, $AddDirection, '')
								$SignalHistory = StringTrimRight($Signal, 1)
								$SignalHistory2 = ""
								_TreeViewAdd()
								If GUICtrlRead($PlaySoundOnNewAP) = 65 Then SoundPlay(@ScriptDir & "\" & $new_AP_sound, 0)
								$timestamp1 = $timestamp
								$timestamp2 = $timestamp
							Else
								$CurrentSignal1 = _GUICtrlListViewGetItemText($ListviewAPs, $arraysearch, $column_SignalHistory)
								$CurrentSignal2 = _GUICtrlListViewGetItemText($ListviewAPs, $arraysearch, $column_SignalHistory2)
								$SignalString = StringTrimRight($Signal, 1) & '-' & $CurrentSignal1 & $CurrentSignal2
								If StringLen($SignalString) > 4095 Then
									$SignalHistory = StringTrimRight($SignalString, StringLen($SignalString) - 4095)
									$SignalHistory2 = StringTrimLeft($SignalString, 4095)
								Else
									$SignalHistory = $SignalString
									$SignalHistory2 = ""
								EndIf
								If StringTrimLeft($Latitude, 2) = '0.0000000'  Or $Latitude = '' Or StringTrimLeft($Longitude, 2) = '0.0000000'  Or $Longitude = '' Or StringTrimLeft(_GUICtrlListViewGetItemText($ListviewAPs, $arraysearch, $column_Latitude), 2) <> '0.0000000'  Then
									Dim $newlat = '', $newlon = ''
								EndIf
								$timestamp1 = ''
								$timestamp2 = $timestamp
							EndIf
							_ListViewAdd($arraysearch, "Active", '', $Signal, $SSID, $BSSID, $Authentication, $Encryption, $RadioType, $Channel, $newlat, $newlon, $BasicTransferRates, $OtherTransferRates, $timestamp1, $timestamp2, $NetworkType, '', $SignalHistory, $SignalHistory2)
							Dim $BSSID = '', $Signal = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = ''
						EndIf
					EndIf
				EndIf
				If ($loop + 1) >= $TempFileArray[0] Then ExitLoop ;If Adding 1 to the loop will make it greater than the array size, ExitLoop so no crash happens
				$loop += 1
			WEnd
		EndIf
	Next
EndFunc   ;==>_ScanAccessPoints

Func _SetActiveAccessPoints_SetManufacturer()
	$itemcount = _GUICtrlListViewGetItemCount($ListviewAPs)
	$Array_Temp_BSSID = StringSplit($ActiveBSSIDs, "|")
	$Array_Temp_SSID = StringSplit($ActiveSSIDs, "|")
	GUICtrlSetData($ActiveAPs, $Array_Temp_BSSID[0] - 1 & ' / ' & $itemcount);Display AP totals in GUI (active APs / total APs)
	
	If $ActiveBSSIDs_old <> $ActiveBSSIDs Then
		For $active = 0 To $itemcount - 1;Go though all rows in the list
			
			$foundactive = 0;Reset active flag
			$ColumnBSSID = _GUICtrlListViewGetItemText($ListviewAPs, $active, $column_BSSID);get BSSID of current column
			$ColumnSSID = _GUICtrlListViewGetItemText($ListviewAPs, $active, $column_SSID);get SSID of current column
			$ColumnMANUF = _GUICtrlListViewGetItemText($ListviewAPs, $active, $column_MANUF);get MANUFACTURER of current column
			$ColumnLABEL = _GUICtrlListViewGetItemText($ListviewAPs, $active, $column_Label);get MANUFACTURER of current column
			$StripedBSSID = StringReplace($ColumnBSSID, ':', '')
			Dim $active_reset = '', $Signal = '', $MANUF = '', $LABEL = ''
			
			For $activearrayloop = 1 To $Array_Temp_BSSID[0];Go though found active points.
				If $Array_Temp_BSSID[$activearrayloop] = $ColumnBSSID And $Array_Temp_SSID[$activearrayloop] = $ColumnSSID Then ;If the active BSSID is in the column being checked, leave it alone (it should already be set active)
					$foundactive = 1; Set active flag to 1, BSSID being searched for has been found
					ExitLoop
				EndIf
			Next
			
			If $ColumnMANUF = '' Then $MANUF = _FindManufacturer(StringTrimRight($StripedBSSID, 6));If the Manufacturer column is empty, set manufactuere;Finf Manufacturer based on the first six chars of the BSSID
			If $ColumnLABEL = '' Then $LABEL = _SetLables($StripedBSSID)
			If $foundactive = 0 Then ;If this row did not have an active access point, then mark it as dead
				$active_reset = 'Dead' 
				$Signal = '0%' 
			EndIf

			_ListViewAdd($active, $active_reset, $MANUF, $Signal, '', '', '', '', '', '', '', '', '', '', '', '', '', $LABEL)
		Next
	EndIf
	Dim $ActiveBSSIDs_old = $ActiveBSSIDs, $ActiveBSSIDs = '', $ActiveSSIDs_old = $ActiveBSSIDs, $ActiveSSIDs = ''
EndFunc   ;==>_SetActiveAccessPoints_SetManufacturer

Func _FindManufacturer($findmac)
	Dim $return = 'Unknown' 
	For $searchmaclist = 1 To $manu_mac[0]
		If StringStripWS(StringUpper($manu_mac[$searchmaclist]), 3) = StringStripWS(StringUpper($findmac), 3) Then
			$return = $manu_manu[$searchmaclist]
			ExitLoop
		EndIf
	Next
	Return ($return)
EndFunc   ;==>_FindManufacturer

Func _SetLables($findmac)
	Dim $return = 'Unknown' 
	For $searchlabellist = 1 To $label_mac[0]
		;msgbox(0, $searchlabellist, $label_mac[$searchlabellist])
		If StringStripWS(StringUpper($label_mac[$searchlabellist]), 3) = StringStripWS(StringUpper($findmac), 3) Then
			$return = $label_label[$searchlabellist]
			ExitLoop
		EndIf
	Next
	Return ($return)
EndFunc   ;==>_SetLables

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       TOGGLE/BUTTON FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _SoundToggle()
	If GUICtrlRead($PlaySoundOnNewAP) = 65 Then
		GUICtrlSetState($PlaySoundOnNewAP, $GUI_UNCHECKED)
	Else
		GUICtrlSetState($PlaySoundOnNewAP, $GUI_CHECKED)
	EndIf
EndFunc   ;==>_SoundToggle

Func _AddApPosToggle()
	If GUICtrlRead($AddNewAPsToTop) = 65 Then
		GUICtrlSetState($AddNewAPsToTop, $GUI_UNCHECKED)
		$AddDirection = -1
	Else
		GUICtrlSetState($AddNewAPsToTop, $GUI_CHECKED)
		$AddDirection = 0
	EndIf
EndFunc   ;==>_AddApPosToggle

Func _GpsToggle()
	If $UseGPS = 1 Then
		$UseGPS = 0
		$disconnected_time = -1
		$Latitude = 'N 0.0000000' 
		$Longitude = 'E 0.0000000' 
		_CloseComPort($ComPort) ;Close The GPS COM port
		GUICtrlSetState($UseGpsGUI, $GUI_UNCHECKED)
		GUICtrlSetData($GpsButton, 'Use GPS')
	Else
		$openport = _OpenComPort($ComPort, $BAUD);Open The GPS COM port
		If $openport = 1 Then
			$UseGPS = 1
			GUICtrlSetState($UseGpsGUI, $GUI_CHECKED)
			GUICtrlSetData($GpsButton, 'Stop GPS')
		Else
			$UseGPS = 0
			GUICtrlSetData($msgdisplay, 'Error opening GPS port')
		EndIf
	EndIf
EndFunc   ;==>_GpsToggle

Func _SortToggle()
	If $AutoSort = 1 Then
		$AutoSort = 0
		GUICtrlSetState($AutoSortGUI, $GUI_UNCHECKED)
	Else
		$AutoSort = 1
		GUICtrlSetState($AutoSortGUI, $GUI_CHECKED)
		$sort_timer = TimerInit()
	EndIf
EndFunc   ;==>_SortToggle

Func ScanToggle()
	If $Scan = 1 Then
		$Scan = 0
		GUICtrlSetState($ScanWifiGUI, $GUI_UNCHECKED)
		GUICtrlSetData($ScanButton, "Scan")
	Else
		$Scan = 1
		GUICtrlSetState($ScanWifiGUI, $GUI_CHECKED)
		GUICtrlSetData($ScanButton, "Stop")
	EndIf
EndFunc   ;==>ScanToggle


Func _GraphToggle()
	If $Graph = 1 Then
		$Graph = 0
		GUISwitch($DataChild)
		GUICtrlDelete($Graphic1);delete graphic so it does not show behind the active controls
		GUISwitch($Vistumbler)
	ElseIf $Graph = 2 Then
		$Graph = 1
		GUISwitch($DataChild)
		GUICtrlDelete($Graphic2)
		$Graphic1 = GUICtrlCreateGraphic($Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height);recreate graphic
		GUISwitch($ControlChild)
		GUICtrlSetData($GraphButton2, "Graph2")
		GUISwitch($Vistumbler)
		_ResetSizes()
	ElseIf $Graph = 0 Then
		$Graph = 1
		GUISwitch($DataChild)
		$Graphic1 = GUICtrlCreateGraphic($Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height);recreate graphic
		GUISwitch($Vistumbler)
		_ResetSizes()
	EndIf
	_SetControlSizes()
EndFunc   ;==>_GraphToggle

Func _GraphToggle2()
	If $Graph = 2 Then
		$Graph = 0
		GUISwitch($DataChild)
		GUICtrlDelete($Graphic2);delete graphic so it does not show behind the active controls
		GUISwitch($Vistumbler)
	ElseIf $Graph = 1 Then
		$Graph = 2
		GUISwitch($DataChild)
		GUICtrlDelete($Graphic1)
		$Graphic2 = GUICtrlCreateGraphic($Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height);recreate graphic
		GUISwitch($ControlChild)
		GUICtrlSetData($GraphButton1, "Graph1")
		GUISwitch($Vistumbler)
		_ResetSizes()
	ElseIf $Graph = 0 Then
		$Graph = 2
		GUISwitch($DataChild)
		$Graphic2 = GUICtrlCreateGraphic($Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height);recreate graphic
		GUISwitch($Vistumbler)
		_ResetSizes()
	EndIf
	_SetControlSizes()
EndFunc   ;==>_GraphToggle2

Func CLOSEClicked()
	FileDelete($tempfile);Delete netsh output file
	_WriteINI(); Write current settings to back to INI file
	If $data_history <> $data_old Then ;If Access point data has changed since load/last save, ask user if they want to save the data
		$savemsg = MsgBox(3, "Save?", "Data has changed. Would you like to save?")
		If $savemsg <> 2 Then
			If $savemsg = 6 Then _ExportData()
			If $UseGPS = 1 Then ;If GPS is active, stop it so the COM port does not stay open
				_GpsToggle()
				;_RunDOS('REGSVR32.EXE /u "' & @ScriptDir & '\NETComm.ocx"');unregister netcomm ocx
				Exit
			Else
				Exit
			EndIf
		EndIf
	Else
		If $UseGPS = 1 Then ;If GPS is active, stop it so the COM port does not stay open
			_GpsToggle()
			Exit
		Else
			Exit
		EndIf
	EndIf
EndFunc   ;==>CLOSEClicked

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GPS FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _OpenComPort($CommPort = '8', $sBAUD = '4800', $s1 = 'N', $s2 = '8', $s3 = '1')
	$return = 0
	$ComError = 0
	$CommSettings = $sBAUD & ',' & $s1 & ',' & $s2 & ',' & $s3
	;	Create NETComm.ocx object
	$NetComm = ObjCreate("NETCommOCX.NETComm")
	If IsObj($NetComm) = 0 Then ;If $NetComm is not an object then netcomm ocx is probrably not installed
		MsgBox(0, '', 'Install Netcomm OCX')
	Else
		$NetComm.CommPort = $CommPort ;Set port number
		$NetComm.Settings = $CommSettings ;Set port settings
		$NetComm.InputLen = 0 ;reads entire buffer
		If $ComError <> 1 Then
			$NetComm.InputMode = 0 ;reads in text mode
			$NetComm.HandShaking = 3 ;uses both RTS and Xon/Xoff handshaking
			$NetComm.PortOpen = "True" 
			$return = 1
		EndIf
	EndIf
	Return ($return)
EndFunc   ;==>_OpenComPort

Func _CloseComPort($CommPort = '8')
	;Close the COM Port
	With $NetComm
		.CommPort = $CommPort ;Set port number
		.PortOpen = "False"                                                                    ;Closes specified COM port
	EndWith
EndFunc   ;==>_CloseComPort

Func _GPSOptions()
	$CloseGpsGUI = 0
	Opt("GUIOnEventMode", 0)  ; Turn Off OnEvent mode
	$GpsOptions = GUICreate("GPS Options", 203, 142, 193, 115)
	GUISetBkColor(0xB9D1EA)
	$GUI_UseGPS = GUICtrlCreateCheckbox("Use GPS", 65, 8, 81, 17)
	If $UseGPS = 1 Then GUICtrlSetState($GUI_UseGPS, $GUI_CHECKED)
	GUICtrlCreateLabel("COM:", 32, 40, 31, 17)
	$GUI_Comport = GUICtrlCreateCombo("1", 72, 40, 81, 25)
	GUICtrlSetData(-1, "2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20", $ComPort)
	GUICtrlCreateLabel("Baud:", 32, 72, 32, 17)
	$GUI_Baud = GUICtrlCreateCombo("4800", 72, 72, 81, 25)
	GUICtrlSetData(-1, "9600|14400|19200|38400|57600|115200", $BAUD)
	$GPS_OK = GUICtrlCreateButton("OK", 32, 104, 65, 25, 0)
	$GPS_Cancle = GUICtrlCreateButton("Cancle", 105, 104, 65, 25, 0)
	GUISetState(@SW_SHOW)
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $GPS_Cancle
				ExitLoop
			Case $GPS_OK
				If GUICtrlRead($GUI_Comport) <> $ComPort And $UseGPS = 1 Then _GpsToggle() ;If the port has changed and gps is turned on then turn off the gps (it will be re-enabled with the new port)
				$ComPort = GUICtrlRead($GUI_Comport)
				$BAUD = GUICtrlRead($GUI_Baud)
				If GUICtrlRead($GUI_UseGPS) = 4 And $UseGPS = 1 Then _GpsToggle()
				If GUICtrlRead($GUI_UseGPS) = 1 And $UseGPS = 0 Then _GpsToggle()
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode
	GUIDelete($GpsOptions)
EndFunc   ;==>_GPSOptions

Func _GpsPositionReset($timeout = 60000)
	If TimerDiff($refresh_gps) > $timeout Then ;Reset Position to default if a new location has not been found within timeout period
		$Latitude = 'N 0.0000000' 
		$Longitude = 'E 0.0000000' 
		$refresh_gps = TimerInit()
	EndIf
EndFunc   ;==>_GpsPositionReset

Func _GetGPS()
	$LatTest = 0
	$timeout = TimerInit()
	$return = 1
	While 1 ;Loop to extract gps data untill location is found or timout time is reached
		If $UseGPS = 0 Then ExitLoop
		$maxtime = GUICtrlRead($sleeptime) * 0.8
		If $maxtime < 800 Then $maxtime = 800
		
		If $NetComm.InBufferCount Then
			$Buffer = $NetComm.InBufferCount
			If $Buffer > 100 And $LatTest = 0 And TimerDiff($timeout) < $maxtime Then
				$inputdata = $NetComm.inputdata
				$gps = StringSplit($inputdata, "$")
				For $readloop = 1 To $gps[0]
					If StringInStr($gps[$readloop], "GPGGA") Then
						_GetGpsData($gps[$readloop])
						If $LatTest = 1 Then ExitLoop
						If TimerDiff($timeout) > $maxtime Then ExitLoop
					EndIf
				Next
				If $LatTest = 1 Then
					$refresh_gps = TimerInit()
					ExitLoop
				EndIf
			EndIf

			If TimerDiff($timeout) > $maxtime Then
				GUICtrlSetData($msgdisplay, 'GPS Timeout')
				ExitLoop
			EndIf
			Sleep($maxtime / 100)
			$disconnected_time = TimerInit() ;reset gps turn off timer
		Else
			If $disconnected_time = -1 Then $disconnected_time = TimerInit()
			If TimerDiff($disconnected_time) > 10000 Then ; If nothing has been found in the buffer for 5 seconds, turn off gps
				$disconnected_time = -1
				$return = 0
				_GpsToggle()
				SoundPlay(@ScriptDir & "\" & $error_sound, 0)
			EndIf
		EndIf
		
	WEnd
	Return ($return)
EndFunc   ;==>_GetGPS

Func _GetGpsData($GpsData) ;Read GPS Receiver Data
	GUICtrlSetData($msgdisplay, $GpsData)
	$data = StringSplit($GpsData, ",")
	If $data[0] > 9 Then
		$lat = StringSplit($data[3], ".")
		$lon = StringSplit($data[5], ".")
		If _ArrayMax($lat, 0, 1) >= 2 And _ArrayMax($lat, 0, 1) >= 2 Then
			;Convert to Min/Sec to Decimal Latitude
			$latD = StringMid((StringRight($lat[1], 2) & "." & StringRight($lat[2], 4)) / 60, 2, 10)
			;Convert to Min/Sec to Decimal Longitude
			$lonD = StringMid((StringRight($lon[1], 2) & "." & StringRight($lon[2], 4)) / 60, 2, 10)
			;Set Location Variables
			$ufLat = StringLeft($lat[1], StringLen($lat[1]) - 2) & $latD
			$ufLon = StringLeft($lon[1], StringLen($lon[1]) - 2) & $lonD
			$Latitude = $data[4] & ' ' & StringFormat('%0.7f', $ufLat);set latitude
			$Longitude = $data[6] & ' ' & StringFormat('%0.7f', $ufLon);set longitude
			If $Latitude <> '' Then $LatTest = 1
		EndIf
	EndIf
EndFunc   ;==>_GetGpsData

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SORT FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _SortTree()
	GUICtrlSetData($msgdisplay, 'Sorting Treeview')
	_GUICtrlTreeViewSort($TreeviewAPs)
	GUICtrlSetData($msgdisplay, '')
EndFunc   ;==>_SortTree


Func _SortOptions()
	Opt("GUIOnEventMode", 0)
	
	$SortOptions = GUICreate("Sort Options", 225, 171, 193, 115)
	GUISetBkColor($BackgroundColor)
	$GUI_AutoSort = GUICtrlCreateCheckbox("Auto Sort", 72, 8, 73, 17)
	If $AutoSort = 1 Then GUICtrlSetState($GUI_AutoSort, $GUI_CHECKED)
	$GUI_SortBy = GUICtrlCreateCombo('Sort By SSID', 8, 40, 201, 25)
	GUICtrlSetData(-1, 'Sort By Network Type|Sort By Authentication|Sort By Encryption|Sort By BSSID|Sort By Signal|Sort By Radio Type|Sort By Channel|Sort By Basic Transfer Rates|Sort By Other Transfer Rates|Sort By Latitude|Sort By Longitude|Sort By First Active|Sort By Last Active|Sort By Active|Sort By Manufacturer', $SortBy)
	$GUI_SortDirection = GUICtrlCreateCombo('Ascending', 7, 73, 201, 25)
	GUICtrlSetData(-1, 'Decending', $SortDirection)
	GUICtrlCreateLabel("Auto Sort every:", 24, 104, 80, 17)
	$GUI_SortTime = GUICtrlCreateInput($SortTime, 112, 104, 33, 21)
	GUICtrlCreateLabel("Seconds", 152, 104, 46, 17)
	$Sort_OK = GUICtrlCreateButton("OK", 32, 135, 73, 25, 0)
	$Sort_Cancle = GUICtrlCreateButton("Cancle", 117, 135, 73, 25, 0)
	GUISetState(@SW_SHOW)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $Sort_Cancle
				ExitLoop
			Case $Sort_OK
				$SortBy = GUICtrlRead($GUI_SortBy)
				$SortDirection = GUICtrlRead($GUI_SortDirection)
				$SortTime = GUICtrlRead($GUI_SortTime)
				If GUICtrlRead($GUI_AutoSort) = 4 And $AutoSort = 1 Then _SortToggle()
				If GUICtrlRead($GUI_AutoSort) = 1 And $AutoSort = 0 Then _SortToggle()
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode
	GUIDelete($SortOptions)
EndFunc   ;==>_SortOptions

Func _HeaderSort()
	$column = GUICtrlGetState($ListviewAPs)
	If $Direction[$column] = 'Ascending'  Then
		Dim $v_sort = _GUICtrlListViewGetSubItemsCount($ListviewAPs)
	Else
		Dim $v_sort[_GUICtrlListViewGetSubItemsCount($ListviewAPs) ]
	EndIf
	If $Direction[$column] = 'Ascending'  Then
		$Direction[$column] = 'Decending' 
	Else
		$Direction[$column] = 'Ascending' 
	EndIf
	_GUICtrlListViewSort($ListviewAPs, $v_sort, $column)
EndFunc   ;==>_HeaderSort

Func _Sort($Sort)
	If $AddDirection = 0 Then
		Dim $v_sort = _GUICtrlListViewGetSubItemsCount($ListviewAPs) ;set ascending
	Else
		Dim $v_sort[_GUICtrlListViewGetSubItemsCount($ListviewAPs) ] ;set descending
	EndIf
	
	If $Sort = 'Sort By SSID'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_SSID)
	ElseIf $Sort = 'Sort By Network Type'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_NetworkType)
	ElseIf $Sort = 'Sort By Authentication'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Authentication)
	ElseIf $Sort = 'Sort By Encryption'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Encryption)
	ElseIf $Sort = 'Sort By BSSID'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_BSSID)
	ElseIf $Sort = 'Sort By Signal'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Signal)
	ElseIf $Sort = 'Sort By Radio Type'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_RadioType)
	ElseIf $Sort = 'Sort By Channel'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Channel)
	ElseIf $Sort = 'Sort By Basic Transfer Rates'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_BasicTransferRates)
	ElseIf $Sort = 'Sort By Other Transfer Rates'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_OtherTransferRates)
	ElseIf $Sort = 'Sort By Latitude'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Longitude)
	ElseIf $Sort = 'Sort By Longitude'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Latitude)
	ElseIf $Sort = 'Sort By First Active'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_FirstActive)
	ElseIf $Sort = 'Sort By Last Active'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_LastActive)
	ElseIf $Sort = 'Sort By Active'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Active)
	ElseIf $Sort = 'Sort By Manufacturer'  Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_MANUF)
	EndIf
	$sort_timer = TimerInit()
EndFunc   ;==>_Sort

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       LISTVIEW/TREEVIEW FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _TreeViewAdd()
	$position = ''
	$channel_array[0] = UBound($channel_array) - 1
	For $l = 1 To $channel_array[0]
		If $channel_array[$l] = StringFormat("%02i", $Channel) Then $position = $channel_position[$l]
	Next
	_TreeViewApInfo($position, StringFormat("%02i", $Channel), $channel_array, $channel_position, $channel_tree)
	
	$position = ''
	$SSID_array[0] = UBound($SSID_array) - 1
	For $l = 1 To $SSID_array[0]
		If $SSID_array[$l] = '(' & $SSID & ')'  Then $position = $SSID_position[$l]
	Next
	_TreeViewApInfo($position, '(' & $SSID & ')', $SSID_array, $SSID_position, $SSID_tree)
	
	$position = ''
	$Encryption_array[0] = UBound($Encryption_array) - 1
	For $l = 1 To $Encryption_array[0]
		If $Encryption_array[$l] = $Encryption Then $position = $Encryption_position[$l]
	Next
	_TreeViewApInfo($position, $Encryption, $Encryption_array, $Encryption_position, $Encryption_tree)
	
	$position = ''
	$Authentication_array[0] = UBound($Authentication_array) - 1
	For $l = 1 To $Authentication_array[0]
		If $Authentication_array[$l] = $Authentication Then $position = $Authentication_position[$l]
	Next
	_TreeViewApInfo($position, $Authentication, $Authentication_array, $Authentication_position, $Authentication_tree)
	
	$position = ''
	$NetworkType_array[0] = UBound($NetworkType_array) - 1
	For $l = 1 To $NetworkType_array[0]
		If $NetworkType_array[$l] = $NetworkType Then $position = $NetworkType_position[$l]
	Next
	_TreeViewApInfo($position, $NetworkType, $NetworkType_array, $NetworkType_position, $NetworkType_tree)
	;_GUICtrlTreeViewSort ($TreeviewAPs)
EndFunc   ;==>_TreeViewAdd

Func _TreeViewApInfo($position, $aptxt, ByRef $array1, ByRef $array2, ByRef $tree)
	If $position = '' Then
		$position = _GUICtrlTreeViewInsertItem($TreeviewAPs, $aptxt, $tree)
		_ArrayAdd($array1, $aptxt)
		_ArrayAdd($array2, $position)
	EndIf
	$text = '(' & $SSID & ')' 
	$apinfo = _GUICtrlTreeViewInsertItem($TreeviewAPs, $text, $position)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'SSID : ' & $SSID, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'BSSID : ' & $BSSID, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'NetworkType : ' & $NetworkType, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Encryption : ' & $Encryption, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Radio Type : ' & $RadioType, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Authentication : ' & $Authentication, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Basic Transfer Rates : ' & $BasicTransferRates, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Other Transfer Rates : ' & $OtherTransferRates, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Network Type: : ' & $NetworkType, $apinfo)
EndFunc   ;==>_TreeViewApInfo

Func _ListViewAdd($line, $Add_Active = '', $Add_MANU = '', $Add_Signal = '', $Add_SSID = '', $Add_BSSID = '', $Add_Authentication = '', $Add_Encryption = '', $Add_RadioType = '', $Add_Channel = '', $Add_Latitude = '', $Add_Longitude = '', $Add_BasicTransferRates = '', $Add_OtherTransferRates = '', $Add_FirstAcvtive = '', $Add_LastActive = '', $Add_NetworkType = '', $Add_Label = '', $Add_SignalHistory = '', $Add_SignalHistory2 = '')
	If $Add_Active <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Active, $Add_Active)
	If $Add_SSID <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_SSID, $Add_SSID)
	If $Add_BSSID <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_BSSID, $Add_BSSID)
	If $Add_MANU <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_MANUF, $Add_MANU)
	If $Add_Signal <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Signal, $Add_Signal)
	If $Add_Authentication <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Authentication, $Add_Authentication)
	If $Add_Encryption <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Encryption, $Add_Encryption)
	If $Add_RadioType <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_RadioType, $Add_RadioType)
	If $Add_Channel <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Channel, $Add_Channel)
	If $Add_Latitude <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Latitude, $Add_Latitude)
	If $Add_Longitude <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Longitude, $Add_Longitude)
	If $Add_BasicTransferRates <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_BasicTransferRates, $Add_BasicTransferRates)
	If $Add_OtherTransferRates <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_OtherTransferRates, $Add_OtherTransferRates)
	If $Add_FirstAcvtive <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_FirstActive, $Add_FirstAcvtive)
	If $Add_LastActive <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_LastActive, $Add_LastActive)
	If $Add_NetworkType <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_NetworkType, $Add_NetworkType)
	If $Add_Label <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Label, $Add_Label)
	If $Add_SignalHistory <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_SignalHistory, $Add_SignalHistory)
	If $Add_SignalHistory2 <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_SignalHistory2, $Add_SignalHistory2)
EndFunc   ;==>_ListViewAdd

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SEARCHWORDS FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _SearchWordsGUI()
	Opt("GUIOnEventMode", 0)
	$SearchWordsGUI = GUICreate("netsh search words", 366, 420, 387, 189)
	GUISetBkColor($BackgroundColor)
	GUICtrlCreateGroup("Description", 8, 8, 345, 81)
	GUICtrlCreateLabel("This section allows you to change the words Vistumbler uses to search", 13, 24, 336, 17)
	GUICtrlCreateLabel("netsh. Change to the proper words for you version of windows.", 13, 43, 298, 17)
	GUICtrlCreateLabel("Run 'netsh wlan show networks mode=bssid' to find the proper words.", 13, 64, 332, 17)
	GUICtrlCreateLabel("SSID:", 8, 96, 29, 17)
	GUICtrlCreateLabel("BSSID:", 8, 128, 36, 17)
	GUICtrlCreateLabel("Network Type:", 8, 160, 74, 17)
	GUICtrlCreateLabel("Authentication:", 8, 192, 75, 17)
	GUICtrlCreateLabel("Signal:", 8, 224, 36, 17)
	GUICtrlCreateLabel("Radio Type:", 8, 256, 59, 17)
	GUICtrlCreateLabel("Channel:", 8, 288, 43, 17)
	GUICtrlCreateLabel("Basic Transfer Rates:", 8, 320, 106, 17)
	GUICtrlCreateLabel("Other Transfer Rates:", 8, 352, 106, 17)
	$SearchWord_SSID_GUI = GUICtrlCreateInput($SearchWord_SSID, 120, 96, 233, 21)
	$SearchWord_BSSID_GUI = GUICtrlCreateInput($SearchWord_BSSID, 120, 128, 233, 21)
	$SearchWord_NetType_GUI = GUICtrlCreateInput($SearchWord_NetworkType, 120, 160, 233, 21)
	$SearchWord_Authentication_GUI = GUICtrlCreateInput($SearchWord_Authentication, 120, 192, 233, 21)
	$SearchWord_Signal_GUI = GUICtrlCreateInput($SearchWord_Signal, 120, 224, 233, 21)
	$SearchWord_RadioType_GUI = GUICtrlCreateInput($SearchWord_RadioType, 120, 256, 233, 21)
	$SearchWord_Channel_GUI = GUICtrlCreateInput($SearchWord_Channel, 120, 288, 233, 21)
	$SearchWord_BasicRates_GUI = GUICtrlCreateInput($SearchWord_BasicRates, 120, 320, 233, 21)
	$SearchWord_OtherRates_GUI = GUICtrlCreateInput($SearchWord_OtherRates, 120, 352, 233, 21)
	$SearchWordsGUI_OK = GUICtrlCreateButton("OK", 110, 384, 75, 25, 0)
	$SearchWordsGUI_Cancle = GUICtrlCreateButton("Cancle", 190, 384, 73, 25, 0)
	GUISetState(@SW_SHOW)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $SearchWordsGUI_Cancle
				ExitLoop
			Case $SearchWordsGUI_OK
				$SearchWord_SSID = GUICtrlRead($SearchWord_SSID_GUI)
				$SearchWord_BSSID = GUICtrlRead($SearchWord_BSSID_GUI)
				$SearchWord_NetworkType = GUICtrlRead($SearchWord_NetType_GUI)
				$SearchWord_Authentication = GUICtrlRead($SearchWord_Authentication_GUI)
				$SearchWord_Signal = GUICtrlRead($SearchWord_Signal_GUI)
				$SearchWord_RadioType = GUICtrlRead($SearchWord_RadioType_GUI)
				$SearchWord_Channel = GUICtrlRead($SearchWord_Channel_GUI)
				$SearchWord_BasicRates = GUICtrlRead($SearchWord_BasicRates_GUI)
				$SearchWord_OtherRates = GUICtrlRead($SearchWord_OtherRates_GUI)
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)
	GUIDelete($SearchWordsGUI)
EndFunc   ;==>_SearchWordsGUI

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GRAPH/CONTROL POSITION FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------
Func _SetControlSizes()
	$a = WinGetPos($Vistumbler)
	WinMove($DataChild, "", 0, 60, $a[2] - 10, $a[3] - 115)
	$b = WinGetPos($DataChild) ;get child window size
	$sizes = $a[0] & '-' & $a[1] & '-' & $a[2] & '-' & $a[3] & '-' & $b[0] & '-' & $b[1] & '-' & $b[2] & '-' & $b[3]
	If $sizes <> $sizes_old Or $Graph <> $Graph_old Or $Redraw = 1 Then
		If $Graph <> 0 Then
			$Graphic_left = ($b[2] * 0.01)
			$Graphic_width = ($b[2] * 0.99) - $Graphic_left
			$Graphic_top = ($b[3] * 0.01)
			$Graphic_height = ($b[3] * 0.64) - $Graphic_top
			
			$ListviewAPs_left = ($b[2] * 0.01)
			$ListviewAPs_width = ($b[2] * 0.99) - $ListviewAPs_left
			$ListviewAPs_top = ($b[3] * 0.65)
			$ListviewAPs_height = ($b[3] * 0.99) - $ListviewAPs_top

			GUICtrlSetState($TreeviewAPs, $GUI_HIDE)
			GUICtrlSetPos($ListviewAPs, $ListviewAPs_left, $ListviewAPs_top, $ListviewAPs_width, $ListviewAPs_height)
			
			If $Graph = 1 Then
				GUICtrlSetPos($Graphic1, $Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height)
				GUICtrlSetData($GraphButton1, "No Graph")
			ElseIf $Graph = 2 Then
				GUICtrlSetPos($Graphic2, $Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height)
				GUICtrlSetData($GraphButton2, "No Graph")
			EndIf
			
			GUICtrlSetState($ListviewAPs, $GUI_FOCUS)
			
		Else
			$TreeviewAPs_left = ($b[2] * 0.01)
			$TreeviewAPs_width = ($b[2] * 0.20) - $TreeviewAPs_left
			$TreeviewAPs_top = ($b[3] * 0.01)
			$TreeviewAPs_height = ($b[3] * 0.99) - $TreeviewAPs_top
			
			$ListviewAPs_left = ($b[2] * 0.20) + 1
			$ListviewAPs_width = ($b[2] * 0.99) - $ListviewAPs_left
			$ListviewAPs_top = ($b[3] * 0.01)
			$ListviewAPs_height = ($b[3] * 0.99) - $ListviewAPs_top
			
			GUICtrlSetState($TreeviewAPs, $GUI_SHOW)
			GUICtrlSetPos($ListviewAPs, $ListviewAPs_left, $ListviewAPs_top, $ListviewAPs_width, $ListviewAPs_height)
			GUICtrlSetPos($TreeviewAPs, $TreeviewAPs_left, $TreeviewAPs_top, $TreeviewAPs_width, $TreeviewAPs_height)
			GUICtrlSetData($GraphButton1, "Graph1")
			GUICtrlSetData($GraphButton2, "Graph2")
			GUICtrlSetState($ListviewAPs, $GUI_FOCUS)
		EndIf
		$sizes_old = $sizes
		$Graph_old = $Graph
	EndIf
EndFunc   ;==>_SetControlSizes

Func _GraphApSignal()
	If $Graph <> 0 Then; If the graph tab is selected, run graph script
		$Selected = _GUICtrlListViewGetCurSel($ListviewAPs); find what AP is selected in the list. returns -1 is nothing is selected
		If $Selected <> -1 Then ;If a access point is selected in the listview, map its data
			$data = _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_SignalHistory) & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_SignalHistory2);get string of signals from the listview (of the AP currently selected) and put it into an array
			If $data <> $data_old Or $sizes <> $sizes_old Or $Redraw = 1 Then ; if graph data changed, map new data
				$max_graph_points = 125
				$base_right = $Graphic_width
				$base_left = 0
				$base_top = 0
				$base_bottom = $Graphic_height
				$base_x = $base_right - $base_left
				$base_y = $base_bottom - $base_top

				$max_graph_points = 125
				$Redraw = 0
				$data_old = $data
				$sizes_old = $sizes
				$splitdata = StringSplit($data, '-');Split signals into an array
				If IsArray($splitdata) Then
					If $Graph = 1 Then
						If $splitdata[0] > $max_graph_points Then ; If the array is grater that the max number of ports, set array size to the max size, else use the full size of the array
							$arraylen = $max_graph_points
						Else
							$arraylen = $splitdata[0]
						EndIf
						$base_x_add_value = ($base_x / ($arraylen - 1)); Set disance between points
						$base_y_add_value = ($base_y / 100); set distance for 1%, this will be multplied by the signal strenth later
						
						GUISwitch($DataChild)
						GUICtrlDelete($Graphic1);delete graphic so new data can be added without showing the old data
						$Graphic1 = GUICtrlCreateGraphic($Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height);recreate graphic
						GUISwitch($Vistumbler)
						
						;############### Start - Draw grid ###############
						;GUICtrlSetGraphic($Graphic1, $GUI_GR_PENSIZE, 1);set size of line
						GUICtrlSetGraphic($Graphic1, $GUI_GR_COLOR, 0x000000)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_left, $base_top)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_left, $base_bottom)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_right, $base_top)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_right, $base_bottom)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_left, $base_bottom)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_right, $base_bottom)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_COLOR, 0xff)
						For $drawline = 1 To 10
							$subtract_value = ($drawline * 10) * $base_y_add_value
							GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_left, $base_bottom - $subtract_value)
							GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_right, $base_bottom - $subtract_value)
						Next
						GUICtrlSetGraphic($Graphic1, $GUI_GR_REFRESH)
						;###############  End - Draw grid ###############
						;############### Start Mapping Access Point signal Data ###############
						$base_add = 0
						;GUICtrlSetGraphic($Graphic1, $GUI_GR_PENSIZE, 2);set size of line
						GUICtrlSetGraphic($Graphic1, $GUI_GR_COLOR, 0xFF0000)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_right - $base_add, $base_bottom - ($splitdata[1] * $base_y_add_value))
						GUICtrlSetGraphic($Graphic1, $GUI_GR_DOT, $base_right - $base_add, $base_bottom - ($splitdata[1] * $base_y_add_value))
						For $o = 2 To $arraylen
							$base_add += $base_x_add_value
							
							GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_right - $base_add, $base_bottom - ($splitdata[$o] * $base_y_add_value))
							GUICtrlSetGraphic($Graphic1, $GUI_GR_DOT, $base_right - $base_add, $base_bottom - ($splitdata[$o] * $base_y_add_value))
						Next
						GUICtrlSetGraphic($Graphic1, $GUI_GR_REFRESH)
						;############### Start Mapping Access Point signal Data ###############
					ElseIf $Graph = 2 Then
						If $splitdata[0] > $base_x Then
							$arraylen = $base_x
							$base_subtract = 0
						Else
							$arraylen = $splitdata[0]
							$base_subtract = $base_x - $splitdata[0]
						EndIf
						$base_y_add_value = ($base_y / 100); set distance for 1%, this will be multplied by the signal strenth later
						GUISwitch($DataChild)
						GUICtrlDelete($Graphic2);delete graphic so new data can be added without showing the old data
						$Graphic2 = GUICtrlCreateGraphic($Graphic_left, $Graphic_top, $Graphic_width, $Graphic_height);recreate graphic
						GUISwitch($Vistumbler)
						;############### Start - Draw grid ###############
						GUICtrlSetGraphic($Graphic1, $GUI_GR_PENSIZE, 1);set size of line
						GUICtrlSetGraphic($Graphic2, $GUI_GR_COLOR, 0x000000)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_left, $base_top)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_left, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_right, $base_top)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_right, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_left, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_right, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_COLOR, 0xff)
						For $drawline = 1 To 10
							$subtract_value = ($drawline * 10) * $base_y_add_value
							GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_left, $base_bottom - $subtract_value)
							GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_right, $base_bottom - $subtract_value)
						Next
						;GUICtrlSetGraphic($Graphic2, $GUI_GR_REFRESH)
						;###############  End - Draw grid ###############
						;############### Start Mapping Access Point signal Data ###############
						$base_add = 0
						$base_x_add_value = 1
						;GUICtrlSetGraphic($Graphic1, $GUI_GR_PENSIZE, 2);set size of line
						GUICtrlSetGraphic($Graphic2, $GUI_GR_COLOR, 0xFF0000)
						For $o = 1 To $arraylen
							$base_add += $base_x_add_value
							GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, ($base_right - $base_add) - $base_subtract, $base_bottom)
							GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, ($base_right - $base_add) - $base_subtract, $base_bottom - ($splitdata[$o] * $base_y_add_value))
						Next
						GUICtrlSetGraphic($Graphic1, $GUI_GR_PENSIZE, 1);set size of line
						GUICtrlSetGraphic($Graphic2, $GUI_GR_COLOR, 0x000000)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_left, $base_top)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_left, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_right, $base_top)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_right, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_left, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_right, $base_bottom)
						GUICtrlSetGraphic($Graphic2, $GUI_GR_COLOR, 0xff)
						For $drawline = 1 To 10
							$subtract_value = ($drawline * 10) * $base_y_add_value
							GUICtrlSetGraphic($Graphic2, $GUI_GR_MOVE, $base_left, $base_bottom - $subtract_value)
							GUICtrlSetGraphic($Graphic2, $GUI_GR_LINE, $base_right, $base_bottom - $subtract_value)
						Next
						GUICtrlSetGraphic($Graphic2, $GUI_GR_REFRESH)
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
EndFunc   ;==>_GraphApSignal

Func _ResetSizes()
	_SetControlSizes()
	$Redraw = 1
EndFunc   ;==>_ResetSizes

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SAVE AND OPEN FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _ViewInPhilsPHP()
	$Selected = _GUICtrlListViewGetCurSel($ListviewAPs); find what AP is selected in the list. returns -1 is nothing is selected
	If $Selected <> -1 Then ;If a access point is selected in the listview, map its data
		;If Ping("randomintervals.com") <> 0 Then
		$url_root = "http://randomintervals.com/wifi/genlineurl.php?" 
		$url_data = "SSID=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_SSID) & "&Mac=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_BSSID) & "&Manuf=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_MANUF) & "&Auth=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_Authentication) & "&Encry=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_Encryption) & "&radio=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_RadioType) & "&Chn=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_Channel) & "&Lat=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_Latitude) & "&Long=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_Longitude) & "&BTx=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_BasicTransferRates) & "&OTx=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_OtherTransferRates) & "&FA=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_FirstActive) & "&LU=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_LastActive) & "&NT=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_NetworkType) & "&Label=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_Label) & "&Sig=" & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_SignalHistory) & _GUICtrlListViewGetItemText($ListviewAPs, $Selected, $column_SignalHistory2)
		$url_full = $url_root & $url_data
		$url_trimmed = StringTrimRight($url_full, StringLen($url_full) - 2083) ;trim sting to internet explorer max url lenth
		$url_trimmed2 = StringTrimRight($url_trimmed, (StringLen($url_trimmed) - StringInStr($url_trimmed, "-", 1, -1)) + 1);find - that marks the last full data and get rid of the rest
		Run("RunDll32.exe url.dll,FileProtocolHandler " & $url_trimmed2);open url with rundll 32
		;_IECreate($url_root & $url_data, 0, 1, 0)
		;Else
		;MsgBox(0, "Error", "randomintervals.com did not respond to a ping. this action can't be done at this time.")
		;EndIf
	Else
		MsgBox(0, "Error", "You did not select an access point")
	EndIf
EndFunc   ;==>_ViewInPhilsPHP

Func _ExportData()
	DirCreate(@ScriptDir & '\save')
	$timestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & '-' & @MIN & '-' & @SEC
	$File = FileSaveDialog("Output File", @ScriptDir & '\save', 'Text (*.txt)', '', $timestamp & '.txt')
	If @error <> 1 Then
		If StringInStr($File, '.txt') = 0 Then $File = $File & '.txt' 
		FileDelete($File)
		$aplistviewcount = _GUICtrlListViewGetItemCount($ListviewAPs)
		For $save = 0 To $aplistviewcount - 1
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $save + 1 & ' / ' & $aplistviewcount)
			FileWriteLine($File, _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_SSID) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_BSSID) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_MANUF) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Signal) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Authentication) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Encryption) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_RadioType) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Channel) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Latitude) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Longitude) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_BasicTransferRates) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_OtherTransferRates) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_FirstActive) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_LastActive) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_NetworkType) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Label) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_SignalHistory) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_SignalHistory2))
		Next
		MsgBox(0, 'Done', 'Saved as: "' & $File & '"')
		GUICtrlSetData($msgdisplay, '')
		$data_old = $data_history
	EndIf
EndFunc   ;==>_ExportData

Func LoadList()
	DirCreate(@ScriptDir & '\save')
	$File = FileOpenDialog("Import File", @ScriptDir & '\save', 'Text (*.txt)')
	If @error <> 1 Then
		$itemcount1 = _GUICtrlListViewGetItemCount($ListviewAPs) - 1; Get List Size - I am setting this here so it only searches entries in the origional list
		$itemcount2 = _GUICtrlListViewGetItemCount($ListviewAPs) - 1; Get List Size - I am setting this here so it only searches entries in the origional list
		
		If StringInStr($File, '.txt') = 0 Then $File = $File & '.txt' 
		_FileReadToArray($File, $OpenArray)
		For $open = 1 To $OpenArray[0] - 1
			GUICtrlSetData($msgdisplay, 'Loading Line ' & $open & ' / ' & $OpenArray[0] - 1)
			$loadlist = StringSplit($OpenArray[$open], '|')
			If IsArray($loadlist) Then
				;MsgBox(0, '', $loadlist[0])
				Dim $SSID = '', $BSSID = '', $MANUF = '', $Signal = '', $Authentication = '', $Encryption = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '', $LoadLatitude = '', $LoadLongitude = '', $FirstActive = '', $LastActive = '', $NetworkType = '';Clear Variables
				If $loadlist[0] = 17 Or $loadlist[0] = 18 Then
					$SSID = StringStripWS($loadlist[1], 3)
					$BSSID = StringStripWS($loadlist[2], 3)
					If $loadlist[3] <> 'Unknown'  Then $MANUF = StringStripWS($loadlist[3], 3)
					;$Signal = StringStripWS($loadlist[4], 3)
					$Authentication = StringStripWS($loadlist[5], 3)
					$Encryption = StringStripWS($loadlist[6], 3)
					$RadioType = StringStripWS($loadlist[7], 3)
					$Channel = StringStripWS($loadlist[8], 3)
					$LoadLatitude = StringStripWS($loadlist[9], 3)
					$LoadLongitude = StringStripWS($loadlist[10], 3)
					$BasicTransferRates = StringStripWS($loadlist[11], 3)
					$OtherTransferRates = StringStripWS($loadlist[12], 3)
					$FirstActive = StringStripWS($loadlist[13], 3)
					$LastActive = StringStripWS($loadlist[14], 3)
					$NetworkType = StringStripWS($loadlist[15], 3)
					$LABEL = StringStripWS($loadlist[16], 3)
					$SignalHistory = StringStripWS($loadlist[17], 3)
					If $loadlist[0] = 18 Then
						$SignalHistory2 = StringStripWS($loadlist[18], 3)
					Else
						$SignalHistory2 = ""
					EndIf
					If $BSSID <> '' Then ; If Mac Address(BSSID) was found write data into
						$arraysearch = -1
						$position = -1 ;set to -1 so APs are being added to the bottom
						
						For $findloop = 0 To $itemcount2; Find BSSID in list; If found, set $arraysearch with position
							If _GUICtrlListViewGetItemText($ListviewAPs, $findloop, $column_BSSID) = $BSSID And _GUICtrlListViewGetItemText($ListviewAPs, $findloop, $column_SSID) = $SSID Then
								$arraysearch = $findloop
								ExitLoop
							EndIf
						Next
						
						If $arraysearch = -1 Then ;If BSSID is not found, add it - Else - Update old entry
							$new = _GUICtrlListViewInsertItem($ListviewAPs, $position, '')
							_ListViewAdd($new, 'Dead', $MANUF, '0%', $SSID, $BSSID, $Authentication, $Encryption, $RadioType, $Channel, $LoadLatitude, $LoadLongitude, $BasicTransferRates, $OtherTransferRates, $FirstActive, $LastActive, $NetworkType, '', $SignalHistory, $SignalHistory2)
							_TreeViewAdd()
						Else
							If StringTrimLeft($LoadLatitude, 2) <> '0.0000000'  And $LoadLatitude <> '' And StringTrimLeft($LoadLongitude, 2) <> '0.0000000'  And $LoadLongitude <> '' And StringTrimLeft(_GUICtrlListViewGetItemText($ListviewAPs, $arraysearch, $column_Latitude), 2) = '0.0000000'  Then

								$CurrentSignal1 = _GUICtrlListViewGetItemText($ListviewAPs, $arraysearch, $column_SignalHistory)
								$CurrentSignal2 = _GUICtrlListViewGetItemText($ListviewAPs, $arraysearch, $column_SignalHistory2)
								$SignalString = $CurrentSignal1 & $CurrentSignal2 & $SignalHistory & $SignalHistory2
								If StringLen($SignalString) > 4095 Then
									$SignalHistory = StringTrimRight($SignalString, StringLen($SignalString) - 4095)
									$SignalHistory2 = StringTrimLeft($SignalString, 4095)
								Else
									$SignalHistory = $SignalString
									$SignalHistory2 = ""
								EndIf
								_ListViewAdd($arraysearch, '', '', '', '', '', '', '', '', '', $LoadLatitude, $LoadLongitude, '', '', '', '', '', '', $SignalHistory, $SignalHistory2)
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		Next
		If $AddDirection = 0 Then
			Dim $v_sort = _GUICtrlListViewGetSubItemsCount($ListviewAPs) ;set ascending
		Else
			Dim $v_sort[_GUICtrlListViewGetSubItemsCount($ListviewAPs) ] ;set descending
		EndIf
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_LastActive)
		MsgBox(0, 'Done', 'Load of file: "' & $File & '" complete')
		GUICtrlSetData($msgdisplay, "")
	EndIf
	$data_old = $data_history
EndFunc   ;==>LoadList

Func SaveToKML()
	DirCreate(@ScriptDir & '\save')
	$timestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & '-' & @MIN & '-' & @SEC
	$kml = FileSaveDialog("Google Earth Output File", @ScriptDir & '\save', 'Google Earth (*.kml)', '', $timestamp & '.kml')
	If @error <> 1 Then
		If StringInStr($kml, '.kml') = 0 Then $kml = $kml & '.kml' 
		FileDelete($kml)
		$File = '<?xml version="1.0" encoding="utf-8"?>' & @CRLF _
				 & '<kml xmlns="http://earth.google.com/kml/2.0">' & @CRLF _
				 & '<Document>' & @CRLF _
				 & '<Style id="secureStyle">' & @CRLF _
				 & '<IconStyle>' & @CRLF _
				 & '<scale>.5</scale>' & @CRLF _
				 & '<Icon>' & @CRLF _
				 & '<href>http://techidiots.net/autoit-scripts/vistumbler/wap-secure.png</href>' & @CRLF _;image from EarthStubler
				 & '</Icon>' & @CRLF _
				 & '</IconStyle>' & @CRLF _
				 & '</Style>' & @CRLF _
				 & '<Style id="openStyle">' & @CRLF _
				 & '<IconStyle>' & @CRLF _
				 & '<scale>.5</scale>' & @CRLF _
				 & '<Icon>' & @CRLF _
				 & '<href>http://techidiots.net/autoit-scripts/vistumbler/wap-open.png</href>' & @CRLF _;image from EarthStubler
				 & '</Icon>' & @CRLF _
				 & '</IconStyle>' & @CRLF _
				 & '</Style>' & @CRLF _
				 & '<Folder>' & @CRLF _
				 & '<description>' & $Script_Name & ' - By ' & $Script_Author & '</description>' & @CRLF _
				 & '<name>' & $Script_Name & ' ' & $version & '</name>' & @CRLF _
				 & '<Folder>' & @CRLF _
				 & '<name>Access Points</name>' & @CRLF _
				 & '<description>Access points found</description>' & @CRLF
		
		$FoundApWithGps = 0
		For $i = 0 To _GUICtrlListViewGetItemCount($ListviewAPs) - 1
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $i + 1 & ' / ' & _GUICtrlListViewGetItemCount($ListviewAPs))
			If _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Latitude) <> '' And _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Latitude) <> 'N 0.0000000'  Then
				$File &= '<Placemark>' & @CRLF _
						 & '<name></name>' & @CRLF _
						 & '<description><![CDATA[<b>SSID: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_SSID) & '<br /><b>BSSID: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_BSSID) & '<br /><b>Network Type: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_NetworkType) & '<br /><b>Radio Type: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_RadioType) & '<br /><b>Channel: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Channel) & '<br /><b>Authentication: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Authentication) & '<br /><b>Encryption: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Encryption) & '<br /><b>Basic Rates: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_BasicTransferRates) & '<br /><b>Other Rates: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_OtherTransferRates) & '<br /><b>First Seen: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_FirstActive) & '<br /><b>Last Seen: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_LastActive) & '<br /><b>Signal: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Signal) & '<br /><b>Latitude: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Latitude) & '<br /><b>Longitude: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Longitude) & '<br /><b>Manufacturer: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_MANUF) & '<br />]]></description>' 
				If _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Authentication) = "Open"  And _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Encryption) = "None"  Then
					$File &= '	<styleUrl>#openStyle</styleUrl>' & @CRLF
				Else
					$File &= '	<styleUrl>#secureStyle</styleUrl>' & @CRLF
				EndIf
				
				$File &= '<Point>' & @CRLF _
						 & '<coordinates>' & StringReplace(StringReplace(StringReplace(_GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Longitude), 'W', '-'), 'E', ''), ' ', '') & ',' & StringReplace(StringReplace(StringReplace(_GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Latitude), 'S', '-'), 'N', ''), ' ', '') & ',0</coordinates>' & @CRLF _
						 & '</Point>' & @CRLF _
						 & '</Placemark>' & @CRLF
				$FoundApWithGps = 1
			EndIf
		Next
		
		$File &= '</Folder>' & @CRLF _
				 & '</Folder>' & @CRLF _
				 & '</Document>' & @CRLF _
				 & '</kml>' & @CRLF
		
		If $FoundApWithGps = 1 Then
			FileWrite($kml, $File)
			MsgBox(0, 'Done', 'Saved as: "' & $kml & '"')
			GUICtrlSetData($msgdisplay, '')
		Else
			MsgBox(0, 'Done', 'No Access Points found with GPS coordinates. No file has been saved')
			GUICtrlSetData($msgdisplay, '')
		EndIf
	EndIf
EndFunc   ;==>SaveToKML

Func _WriteINI()
	;Get new order of columns to write back to INI
	$currentcolumn = StringSplit(_GUICtrlListViewGetColumnOrder($ListviewAPs), '|')
	;_ArrayDisplay($currentcolumn)
	For $c = 1 To $currentcolumn[0]
		If $column_Active = $currentcolumn[$c] Then
			$save_column_Active = $c - 1
		ElseIf $column_SSID = $currentcolumn[$c] Then
			$save_column_SSID = $c - 1
		ElseIf $column_BSSID = $currentcolumn[$c] Then
			$save_column_BSSID = $c - 1
		ElseIf $column_MANUF = $currentcolumn[$c] Then
			$save_column_MANUF = $c - 1
		ElseIf $column_Signal = $currentcolumn[$c] Then
			$save_column_Signal = $c - 1
		ElseIf $column_Authentication = $currentcolumn[$c] Then
			$save_column_Authentication = $c - 1
		ElseIf $column_Encryption = $currentcolumn[$c] Then
			$save_column_Encryption = $c - 1
		ElseIf $column_RadioType = $currentcolumn[$c] Then
			$save_column_RadioType = $c - 1
		ElseIf $column_Channel = $currentcolumn[$c] Then
			$save_column_Channel = $c - 1
		ElseIf $column_Latitude = $currentcolumn[$c] Then
			$save_column_Latitude = $c - 1
		ElseIf $column_Longitude = $currentcolumn[$c] Then
			$save_column_Longitude = $c - 1
		ElseIf $column_BasicTransferRates = $currentcolumn[$c] Then
			$save_column_BasicTransferRates = $c - 1
		ElseIf $column_OtherTransferRates = $currentcolumn[$c] Then
			$save_column_OtherTransferRates = $c - 1
		ElseIf $column_FirstActive = $currentcolumn[$c] Then
			$save_column_FirstActive = $c - 1
		ElseIf $column_LastActive = $currentcolumn[$c] Then
			$save_column_LastActive = $c - 1
		ElseIf $column_NetworkType = $currentcolumn[$c] Then
			$save_column_NetworkType = $c - 1
		ElseIf $column_Label = $currentcolumn[$c] Then
			$save_column_Label = $c - 1
		ElseIf $column_SignalHistory = $currentcolumn[$c] Then
			$save_column_SignalHistory = $c - 1
		ElseIf $column_SignalHistory2 = $currentcolumn[$c] Then
			$save_column_SignalHistory2 = $c - 1
		EndIf
	Next

	;write ini settings
	IniWrite($settings, 'Vistumbler', 'Netsh_exe', $netsh)
	IniWrite($settings, 'Vistumbler', 'ComPort', $ComPort)
	IniWrite($settings, 'Vistumbler', 'Baud', $BAUD)
	IniWrite($settings, 'Vistumbler', 'Sleeptime', GUICtrlRead($sleeptime))
	IniWrite($settings, 'Vistumbler', 'AutoSortTime', $SortTime)
	IniWrite($settings, 'Vistumbler', 'SortCombo', $SortBy)
	IniWrite($settings, 'Vistumbler', 'AscDecDefault', $SortDirection)
	IniWrite($settings, 'Vistumbler', 'AutoSort', $AutoSort)
	IniWrite($settings, 'Vistumbler', 'NewAP_Sound', $new_AP_sound)
	IniWrite($settings, 'Vistumbler', 'Error_Sound', $error_sound)
	IniWrite($settings, 'Vistumbler', 'NewApPosistion', $AddDirection)
	If GUICtrlRead($PlaySoundOnNewAP) = 65 Then
		IniWrite($settings, 'Vistumbler', 'PlaySoundOnNewAP', 1)
	Else
		IniWrite($settings, 'Vistumbler', 'PlaySoundOnNewAP', 0)
	EndIf
	
	IniWrite($settings, 'Columns', 'Column_Active', $save_column_Active)
	IniWrite($settings, 'Columns', 'Column_SSID', $save_column_SSID)
	IniWrite($settings, 'Columns', 'Column_BSSID', $save_column_BSSID)
	IniWrite($settings, 'Columns', 'Column_Manufacturer', $save_column_MANUF)
	IniWrite($settings, 'Columns', 'Column_Signal', $save_column_Signal)
	IniWrite($settings, 'Columns', 'Column_Authentication', $save_column_Authentication)
	IniWrite($settings, 'Columns', 'Column_Encryption', $save_column_Encryption)
	IniWrite($settings, 'Columns', 'Column_RadioType', $save_column_RadioType)
	IniWrite($settings, 'Columns', 'Column_Channel', $save_column_Channel)
	IniWrite($settings, 'Columns', 'Column_Latitude', $save_column_Latitude)
	IniWrite($settings, 'Columns', 'Column_Longitude', $save_column_Longitude)
	IniWrite($settings, 'Columns', 'Column_BasicTransferRates', $save_column_BasicTransferRates)
	IniWrite($settings, 'Columns', 'Column_OtherTransferRates', $save_column_OtherTransferRates)
	IniWrite($settings, 'Columns', 'Column_FirstActive', $save_column_FirstActive)
	IniWrite($settings, 'Columns', 'Column_LastActive', $save_column_LastActive)
	IniWrite($settings, 'Columns', 'Column_NetworkType', $save_column_NetworkType)
	IniWrite($settings, 'Columns', 'Column_Label', $save_column_Label)
	IniWrite($settings, 'Columns', 'Column_SignalHistory', $save_column_SignalHistory)
	IniWrite($settings, 'Columns', 'Column_SignalHistory2', $save_column_SignalHistory2)
	
	IniWrite($settings, 'Column_Width', 'Column_Active', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Active - 0))
	IniWrite($settings, 'Column_Width', 'Column_SSID', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_SSID - 0))
	IniWrite($settings, 'Column_Width', 'Column_BSSID', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_BSSID - 0))
	IniWrite($settings, 'Column_Width', 'Column_Manufacturer', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_MANUF - 0))
	IniWrite($settings, 'Column_Width', 'Column_Signal', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Signal - 0))
	IniWrite($settings, 'Column_Width', 'Column_Authentication', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Authentication - 0))
	IniWrite($settings, 'Column_Width', 'Column_Encryption', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Encryption - 0))
	IniWrite($settings, 'Column_Width', 'Column_RadioType', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_RadioType - 0))
	IniWrite($settings, 'Column_Width', 'Column_Channel', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Channel - 0))
	IniWrite($settings, 'Column_Width', 'Column_Latitude', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Latitude - 0))
	IniWrite($settings, 'Column_Width', 'Column_Longitude', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Longitude - 0))
	IniWrite($settings, 'Column_Width', 'Column_BasicTransferRates', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_BasicTransferRates - 0))
	IniWrite($settings, 'Column_Width', 'Column_OtherTransferRates', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_OtherTransferRates - 0))
	IniWrite($settings, 'Column_Width', 'Column_FirstActive', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_FirstActive - 0))
	IniWrite($settings, 'Column_Width', 'Column_LastActive', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_LastActive - 0))
	IniWrite($settings, 'Column_Width', 'Column_NetworkType', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_NetworkType - 0))
	IniWrite($settings, 'Column_Width', 'Column_Label', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Label - 0))
	IniWrite($settings, 'Column_Width', 'Column_SignalHistory', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_SignalHistory - 0))
	IniWrite($settings, 'Column_Width', 'Column_SignalHistory2', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_SignalHistory2 - 0))
	
	IniWrite($settings, 'SearchWords', 'SSID', $SearchWord_SSID)
	IniWrite($settings, 'SearchWords', 'BSSID', $SearchWord_BSSID)
	IniWrite($settings, 'SearchWords', 'NetworkType', $SearchWord_NetworkType)
	IniWrite($settings, 'SearchWords', 'Authentication', $SearchWord_Authentication)
	IniWrite($settings, 'SearchWords', 'Encryption', $SearchWord_Encryption)
	IniWrite($settings, 'SearchWords', 'Signal', $SearchWord_Signal)
	IniWrite($settings, 'SearchWords', 'RadioType', $SearchWord_RadioType)
	IniWrite($settings, 'SearchWords', 'Channel', $SearchWord_Channel)
	IniWrite($settings, 'SearchWords', 'BasicRates', $SearchWord_BasicRates)
	IniWrite($settings, 'SearchWords', 'OtherRates', $SearchWord_OtherRates)
EndFunc   ;==>_WriteINI

Func MyErrFunc()
	; Set @ERROR to 1 and return control to the program following the trapped error
	;SetError(1)
	;MsgBox(0, "Error", "COM Error" );& $com.CommPort)
	;$UseGPS = 0
	; Exit
	$ComError = 1
EndFunc   ;==>MyErrFunc